
#property link      "http://www.mql4.info/"
#include <stdlib.mqh>

extern int myMagic = 19632;

extern int TakeProfit = 1000;
extern int TakeProfit2 = 200; //0 - disable. close half after this proft
extern int StopLoss = 200;  
extern int BreakEvenStop = 20000;  
extern int TrailingStop = 50000;  
extern int TrailingStep = 10;  
extern int StopNewTradesAfterProfitPips=0; //0 -disabled
extern string CountProfitFrom="00:00";

extern double Lots = 1.0;      //fixed lot 
double MaximumRisk=1;
bool   FixedLot = true; //trigger to use MM
//extern string i2="__BBands_Stop__";
extern int    Length=25;      // Bollinger Bands Period
extern int    Deviation=2;    // Deviation was 2
extern double MoneyRisk=0.5; // Offset Factor
extern int    Signal=1;       // Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals;
extern int    Line=1;         // Display line mode: 0-no,1-yes  
extern int    Nbars=2000;
extern bool SoundON=false;


extern int    Length1=10;      // Bollinger Bands Period
extern int    Deviation1=2;    // Deviation was 2
extern double MoneyRisk1=1.00; // Offset Factor
extern int    Signal1=1;       // Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals;
extern int    Line1=1;         // Display line mode: 0-no,1-yes  
extern int    Nbars1=2000;
extern bool SoundON1=false;








extern int    shift=1;  //shift to current bar, 0 - use current bar, 1 - use last closed bar (trade on next bar open)

extern int    slippage=30;   	//slippage for market order processing
extern bool   ECN_Orders=true;    //true - send market order without sl/tp and modify it later
extern int    OrderTriesNumber=5; //to repeate sending orders when got some error

extern bool WriteScreenshots=true;
extern string    EAName="Semafor"; 

bool buysig,sellsig,closebuy,closesell,trchanged; //flags for signals
int lastsig,tries,at,at2,co,co2,btrend,bzlo,bzhi,szlo,szhi,bzlo_p,bzhi_p,szlo_p,szhi_p,btr2,str2,tzlo,tzhi;


void start()  {
   
   
   
   if(IsTradeAllowed()==false) return;
            
   co=CalculateCurrentOrders();
   if (co!=co2)
      Screenshot("position change");
   co2=co;
   
   CheckForSignals();

   if (co==0)     //---- calculate open orders by current symbol
      CheckForOpen();
   else {
      CheckForClose();
      BreakEvenStop();
      TrailStop();
   }
        
}

double LotsRisk(int StopLoss)  { 
   double lot=Lots,risk=MaximumRisk;
   int SL=StopLoss;
   if (SL<=0) {
      SL=100;
      if (Digits==5 || Digits==3) SL=1000;
   }
   double minlot=MarketInfo(Symbol(),MODE_MINLOT);
   int nl=0;
   if (minlot<1) nl=1;
   if (minlot<0.1) nl=2;
   if (minlot<0.01) nl=3;
//---- select lot size
   if (!FixedLot)
      lot=NormalizeDouble(AccountBalance()*risk*0.001/SL,nl);
//---- return lot size
   lot=MathMax(lot,minlot);
   return(lot);
}

double NMLot(double lot) {
   double minlot=MarketInfo(Symbol(),MODE_MINLOT);
   int nl=0;
   if (minlot<1) nl=1;
   if (minlot<0.1) nl=2;
   if (minlot<0.01) nl=3;
   double rlot=NormalizeDouble(lot,nl);
   return(rlot);
}

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()  {
   int ord;
//----
   for(int i=0;i<OrdersTotal();i++) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==myMagic) ord++;
   }
//---- return orders volume
   return(ord);
}

int CalculateMyProfit()  {
   int pips,ot,st;
   st=StrToTime(CountProfitFrom);
   if (TimeCurrent()<st)
      st=st-24*60*60;
   for (int i=OrdersHistoryTotal()-1; i>=0; i--) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) continue;
      ot=OrderOpenTime();
      if (ot<st) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==myMagic) {
         if (OrderType()==OP_BUY)
            pips=pips+(OrderClosePrice()-OrderOpenPrice())/Point;
         if (OrderType()==OP_SELL)
            pips=pips+(-OrderClosePrice()+OrderOpenPrice())/Point;
      }
   }
   return(pips);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {

      string cmt;
      //indicators variables
      double bb_b1 = iCustom(NULL,0,"BBands_Stop_v1_with_alert",Length,Deviation,MoneyRisk,Signal,Line,Nbars,SoundON,0,shift); 
      double bb_s1 = iCustom(NULL,0,"BBands_Stop_v1_with_alert",Length,Deviation,MoneyRisk,Signal,Line,Nbars,SoundON,1,shift); 
      double bb_b2 = iCustom(NULL,0,"BBands_Stop_v1_with_alert",Length,Deviation,MoneyRisk,Signal,Line,Nbars,SoundON,0,shift+1); 
      double bb_s2 = iCustom(NULL,0,"BBands_Stop_v1_with_alert",Length,Deviation,MoneyRisk,Signal,Line,Nbars,SoundON,1,shift+1); 
      
      double bb_b3 = iCustom(NULL,0,"BBands_Stop_v1_with_alert",Length1,Deviation1,MoneyRisk1,Signal1,Line1,Nbars1,SoundON1,0,shift); 
      double bb_s3 = iCustom(NULL,0,"BBands_Stop_v1_with_alert",Length1,Deviation1,MoneyRisk1,Signal1,Line1,Nbars1,SoundON1,1,shift); 
      double bb_b4 = iCustom(NULL,0,"BBands_Stop_v1_with_alert",Length1,Deviation1,MoneyRisk1,Signal1,Line1,Nbars1,SoundON1,0,shift+1); 
      double bb_s4 = iCustom(NULL,0,"BBands_Stop_v1_with_alert",Length1,Deviation1,MoneyRisk1,Signal1,Line1,Nbars1,SoundON1,1,shift+1); 
      
      
      
            
      
      
      
      //double ma = iCustom(NULL,0,"Moving Averages",MA_Period,MA_Shift,Ma_Method,0,shift);
      
      if (bb_b1>0 && bb_s2>0 ) trchanged=true;
      if (bb_s1>0 && bb_b2>0) trchanged=true;
     cmt="trchanged="+trchanged;
     if (!trchanged) { Comment(cmt); return; }

      double zz_u1,zz_u2,zz_u3,zz_d1,zz_d2,zz_d3;
      
      if (bb_b1>0 && bb_b3<0)  {
       
         
         btrend=1; 
         if (str2!=0) str2=0;
      
      }
      if (bb_s1>0 && bb_s3<0) {
      
          
         btrend=-1;
         if (btr2!=0) btr2=0;
      }
      
     
      
      cmt=cmt+" btrend="+btrend+" bzlo="+bzlo+" bzhi="+bzhi+" szlo="+szlo+" szhi="+szhi+" zz_u1="+zz_u1+" zz_d1="+zz_d1;
      Comment(cmt);
      
      buysig=false;
          
      sellsig=false;
      //long entry signal condition
       
       
      
      
      if (btrend>0 && bb_b3>0)  {
         
         buysig=true;
    
              
      }
                 
           
            
      //short entry signal
                 
      
      if (btrend<0 && bb_s3>0) {
      
          sellsig=true;
      }
      
      
      if (StopNewTradesAfterProfitPips>0) {
         if (CalculateMyProfit()>=StopNewTradesAfterProfitPips) {
            buysig=false;
            sellsig=false;
         }
      }
      

   
      
      closebuy=false;
      closesell=false;
      //long exit signal
      if (bb_b1<0) {
      
        
       
          closebuy=true;
      }
     
      //short exit signal
      
      
      
      if (bb_b1>0) { 
      
     
     
          
          closesell=true;
     
     }
}

void CheckForOpen() {
   int    res,tr;
   
//---- sell conditions
   if(sellsig && lastsig!=Time[0] && str2!=-1 )  {
      Screenshot("sell open");
      res=OpenOrder(OP_SELL,LotsRisk(StopLoss),0,StopLoss,TakeProfit);
      if (res>0) { lastsig=Time[0]; str2=-1; }
      return;
   }
//---- buy conditions
   if(buysig && lastsig!=Time[0] && btr2!=1 )  {
      Screenshot("buy open");
      res=OpenOrder(OP_BUY,LotsRisk(StopLoss),0,StopLoss,TakeProfit);
      if (res>0) { lastsig=Time[0]; btr2=1; }
      return;
   }
}
  
int OpenOrder(int type,double lot,double openpr,int SL,int TP) {
   int    res,tr,col,kk;
   double openprice,sl,tp;
   tries=0;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (type==OP_SELL) {
         openprice=Bid; 
         if (SL>0) sl=openprice+SL*Point;
         if (TP>0) tp=openprice-TP*Point;
         col=Red;
      } else if (type==OP_BUY) {
         openprice=Ask;
         if (SL>0) sl=openprice-SL*Point;
         if (TP>0) tp=openprice+TP*Point;
         col=Blue;
      } else if (type==OP_SELLSTOP || type==OP_SELLLIMIT) {
         openprice=openpr;
         if (SL>0) sl=openprice+SL*Point;
         if (TP>0) tp=openprice-TP*Point;
         col=Red;
      } else {
         openprice=openpr;
         if (SL>0) sl=openprice-SL*Point;
         if (TP>0) tp=openprice+TP*Point;
         col=Blue;
      }
      if (type!=OP_BUY && type!=OP_SELL) {
         res=OrderSend(Symbol(),type,lot,openprice,slippage,sl,tp,EAName+"_"+myMagic,myMagic,0,col);
      } else {
         if (!ECN_Orders)
            res=OrderSend(Symbol(),type,lot,openprice,slippage,sl,tp,EAName+"_"+myMagic,myMagic,0,col);
         else {
            res=OrderSend(Symbol(),type,lot,openprice,slippage,0,0,EAName+"_"+myMagic,myMagic,0,col);
            if (res>0) {
               kk=0;
               while (kk<7) {
                  kk++;
                  if (OrderSelect(res,SELECT_BY_TICKET)) {
                     if (OrderModify(res,OrderOpenPrice(),sl,tp,OrderExpiration(),col)) break;
                     else Sleep(1000);
                  } else Sleep(1000);
               }
            }
         }
      }
      tries++;
   }
   if (res<=0) Print("Error opening order : ",ErrorDescription(GetLastError()));
   return(res);
}
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
   bool bres;
   double clot;
   for(int i=OrdersTotal()-1;i>=0;i--) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  continue;
      if(OrderMagicNumber()!=myMagic || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && closebuy) {
         Screenshot("buy close");
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if(OrderType()==OP_SELL && closesell) {
         Screenshot("sell close");
         bres=CloseAtMarket(OrderTicket(),OrderLots());
         continue;
      }
      if (TakeProfit2>0) { //close half-order
         if (OrderType()==OP_BUY && OrderLots()>=Lots-0.00001 && (OrderClosePrice()-OrderOpenPrice())>=TakeProfit2*Point) {
            clot=NMLot(OrderLots()/1.3);
            Screenshot("buy tp2");
            bres=CloseAtMarket(OrderTicket(),clot);
            continue;
         }
         if (OrderType()==OP_SELL && OrderLots()>=Lots-0.00001 && (-OrderClosePrice()+OrderOpenPrice())>=TakeProfit2*Point) {
            clot=NMLot(OrderLots()/1.3);
            Screenshot("sell tp2");
            bres=CloseAtMarket(OrderTicket(),clot);
            continue;
         }
      }
   }
}

bool CloseAtMarket(int ticket,double lot) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      tries++;
   }
   if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(bres);
}

void TrailStop() {
   bool bres;
   double StopLoss;
   if ( TrailingStop > 0 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != myMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+TrailingStop*Point )  continue;
            StopLoss = Bid-TrailingStop*Point;
            if ( StopLoss >= OrderStopLoss()+TrailingStep*Point ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-TrailingStop*Point )  continue;
            StopLoss = Ask+TrailingStop*Point;
            if ( StopLoss <= OrderStopLoss()-TrailingStep*Point || OrderStopLoss()<Point ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}

void BreakEvenStop() {
   bool bres;
   double StopLoss;
   if ( BreakEvenStop > 0 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != myMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+BreakEvenStop*Point )  continue;
            StopLoss = OrderOpenPrice();
            if ( StopLoss >= OrderStopLoss()+Point ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-BreakEvenStop*Point )  continue;
            StopLoss = OrderOpenPrice();
            if ( StopLoss <= OrderStopLoss()-Point || OrderStopLoss()<Point ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}

void Screenshot(string moment_name) 
{
    if ( !IsTesting() && WriteScreenshots )
    //if ( WriteScreenshots )
        WindowScreenShot(WindowExpertName()+"\\"+WindowExpertName()+"_"+Symbol()+"_M"+Period()+"_"+
                         Year()+"-"+two_digits(Month())+"-"+two_digits(Day())+"_"+
                         two_digits(Hour())+"-"+two_digits(Minute())+"-"+two_digits(Seconds())+"_"+
                         moment_name+".gif", 1024, 768);
}

string two_digits(int i)
{
    if (i < 10)
        return ("0"+i);
    else
        return (""+i);
}

